/*
* LMDB Abstraction Layer.
 * Copyright (C) 2023  Yury Gubich <blue@macaw.me>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#pragma once

#include "base.h"

namespace LMDBAL {

class Session {
    friend class Base;
public:
    explicit Session();
    ~Session();
    Session(const Session&) = delete;
    Session(Session&&);

    Session& operator = (const Session&) = delete;
    Session& operator = (Session&&);

    void close();
    bool opened() const;

private:
    Base* parent;

private:
    Session(Base* parent);
    void terminate();
};

}
